export declare enum Color {
    red = 0,
    black = 1
}
export declare type Id = string | number;
export declare type AugmentedNode<T> = Node<T> & T;
export interface NodeKeys {
    id?: Id;
    parentId?: Id;
}
export interface NodeReferences<T> {
    children?: Array<AugmentedNode<T>>;
    parent?: Node<T>;
}
export interface NodeData<T> {
    data?: T;
}
export interface NodeOptions<T> extends NodeKeys, NodeReferences<T>, NodeData<T> {
    color?: Color;
    left?: Node<T>;
    right?: Node<T>;
}
/**
 * The data nodes used within a collection.  This generally would not be
 * used outside of these collection classes.
 */
export declare class Node<T> implements NodeOptions<T> {
    _options?: NodeOptions<T>;
    id?: Id;
    parentId?: Id;
    children?: Array<AugmentedNode<T>>;
    parent?: Node<T>;
    data?: T;
    color?: Color;
    left?: Node<T>;
    right?: Node<T>;
    constructor(options?: NodeOptions<T>);
    clear?(): void;
    toString(): string;
}
export declare const nilNode: Node<any>;
export default Node;
