import { Comparator } from "./comparator";
import { List } from "./list";
/**
 * A linked list structure that sorts the data in ascending order as it is
 * added.
 *
 */
export declare class SortedList<T> extends List<T> {
    constructor(arr?: T[], comparator?: Comparator<T>);
    /**
     * Inserts a data value into a linked list in its insertion sorted
     * position.  The sort is in ascending order.  The `.reverse` property
     * can be used to get the opposite sort (returned array)
     * @param data {T} the data item to insert into the list
     */
    insert(data: T): void;
}
