import { Collection } from "./collection";
import { Comparator } from "./comparator";
/** Simple stack class */
export declare class Stack<T> extends Collection<T> {
    constructor(comparator?: Comparator<T>);
    /**
     * A convenience method for calling top.
     * @returns {Object} the data element at the top of the stack
     */
    peek(): T;
    /**
     * Puts a data element on the top of the stack
     * @param data {Object} any data element the user wants to store
     */
    push(data: T): void;
    /**
     * Retrieves the top item from the stack and returns it.
     * @returns {Object} the data element at the top of the stack.
     */
    pop(): T;
    /**
     * Retrieves the data element at the top of the stack without removing
     * it.  This clones the object so that changes will not affect what is
     * actually on the top of the stack.
     * @returns {Object} a reference to the data element at the top of the
     * stack.
     */
    top(): T;
}
