import { Collection } from "./collection";
import { Comparator } from "./comparator";
import { Node } from "./node";
/**
 * The abstract base class for all Tree data structures
 *
 */
export declare abstract class Tree<T> extends Collection<T> {
    protected _height: number;
    protected _x: Node<T>;
    constructor(comparator?: Comparator<T>);
    /**
     * Initializes the object to an emtpy state.  This can be used to
     * quickly empty the tree and start over.
     */
    clear(): void;
}
